package com.example.wanandroidformine.adapter

import android.app.Activity
import android.app.Application
import android.os.Bundle
import android.util.Log
import com.example.wanandroidformine.AppManager


/**
 *
 *   ActivityLifecycleCallbacksAdapter
 *   @meaning
 *   @remarks
 *  ╮(￣▽￣)╭
 *   @author QJ Shi
 *   @date 2022/9/6
 */
class ActivityLifecycleCallbacksAdapter (

    private var onActivityCreated: ((activity: Activity, savedInstanceState: Bundle?) -> Unit)? = null
//    private var onActivityStarted: ((activity: Activity) -> Unit)? = null,
//    private var onActivityResumed: ((activity: Activity) -> Unit)? = null,
//    private var onActivityPaused:((activity: Activity) -> Unit)? = null,
//    private var onActivityStopped:((activity: Activity) -> Unit)? = null,
//    private var onActivitySaveInstanceState:((activity: Activity, outState: Bundle) -> Unit)? = null,
//    private var onActivityDestroyed:((activity: Activity) -> Unit)? = null
    ) : Application.ActivityLifecycleCallbacks {
        override fun onActivityCreated(activity: Activity, savedInstanceState: Bundle?) {
            onActivityCreated?.invoke(activity, savedInstanceState)

            var apManager: AppManager = AppManager()
            apManager.attach(activity)

            Log.d("luoah", "[AppApplication.java] -- onActivityCreated -- activity:" + activity);
        }

        override fun onActivityStarted(activity: Activity) {
            Log.d("luoah", "[AppApplication.java] -- onActivityStarted -- activity:" + activity);
        }

        override fun onActivityResumed(activity: Activity) {
            Log.d("luoah", "[AppApplication.java] -- onActivityResumed -- activity:" + activity);
        }

        override fun onActivityPaused(activity: Activity) {
            Log.d("luoah", "[AppApplication.java] -- onActivityPaused -- activity:" + activity);
        }

        override fun onActivityStopped(activity: Activity) {
            Log.d("luoah", "[AppApplication.java] -- onActivityStopped -- activity:" + activity);
        }

        override fun onActivitySaveInstanceState(activity: Activity, outState: Bundle) {
            Log.d("luoah", "[AppApplication.java] -- onActivitySaveInstanceState -- activity:" + activity);
        }

        override fun onActivityDestroyed(activity: Activity) {
            Log.d("luoah", "[AppApplication.java] -- onActivityDestroyed -- activity:" + activity);
            var apManager: AppManager = AppManager()
            apManager.detach(activity)
        }


}