package com.example.wanandroidformine.main.home

import com.example.wanandroidformine.javaBean.BannerBean
import com.example.wanandroidformine.javaBean.HomeListBean
import com.example.wanandroidformine.net.Response
import io.reactivex.Observable


/**
 *
 *   HomeContract
 *   @meaning
 *   @remarks
 *  ╮(￣▽￣)╭
 *   @author QJ Shi
 *   @date 2022/9/13
 */
interface HomeContract {



    interface View {
        fun getHomeListSuccess(homeListBean: HomeListBean , isRefresh: Boolean)
        fun getHomeListFail(msg: String,isRefresh: Boolean)
        fun showBanner(banners: List<BannerBean>, isRefresh: Boolean)
        fun getBannerFail(errorMsg: String,isRefresh: Boolean)
    }

    interface Mode{
        fun getHomeList(page: Int): Observable<Response<HomeListBean>>
        fun getBannerData(): Observable<Response<List<BannerBean>>>

    }

    interface  Presenter{
        fun getHomeList(isRefresh: Boolean)
        fun getBannerData(isRefresh: Boolean)

    }

}