package com.example.wanandroidformine.main.home


import com.blankj.utilcode.util.ToastUtils
import com.example.wanandroidformine.net.response.ResponseTransformer
import com.example.wanandroidformine.net.schedules.BaseSchedulerProvider
import com.orhanobut.logger.Logger
import io.reactivex.disposables.CompositeDisposable
import io.reactivex.disposables.Disposable



/**
 *
 *   HomePresenter
 *   @meaning
 *   @remarks
 *  ╮(￣▽￣)╭
 *   @author QJ Shi
 *   @date 2022/9/13
 */
class HomePresenter(scheduler: BaseSchedulerProvider, view: HomeContract.View) : HomeContract.Presenter {

    private var page: Int = 0

    private var view: HomeContract.View? = null

    private var scheduler: BaseSchedulerProvider? = null

    private val model: HomeModel by lazy {
        HomeModel()
    }

    init {
        this.view = view
        this.scheduler = scheduler
    }


    private val compositeDisposable: CompositeDisposable by lazy {
        CompositeDisposable()
    }


    override fun getHomeList(isRefresh: Boolean) {

        ToastUtils.showShort("开始加载数据...")
        if (isRefresh) {
            page = 0
        }
        var disposable:Disposable=model.getHomeList(page).compose(ResponseTransformer.handleResult()).compose(scheduler?.applySchedulers())
            .subscribe(
                {   homeListBean ->
                    view?.getHomeListSuccess(homeListBean,isRefresh)
                        page++
                    ToastUtils.showShort("数据加载成功！")
                },{
                    throwable ->
                    view?.getHomeListFail(throwable.message+"", isRefresh)
                    ToastUtils.showShort("数据加载失败！"+throwable.message)

                }

            )
        compositeDisposable.add(disposable)

    }

    override fun getBannerData(isRefresh: Boolean) {

        var compose: Disposable? = model?.getBannerData()?.
        compose(scheduler?.applySchedulers())?.
        compose(ResponseTransformer.handleResult())?.
        subscribe(
            { it ->
                view?.showBanner(it, isRefresh)

            },
            { e ->
                view?.getBannerFail(e.message!!, isRefresh)
            }
        )
        compositeDisposable.add(compose!!)
    }
}