package com.example.wanandroidformine.net

import com.example.wanandroidformine.utils.SharePreferencesContants
import com.example.wanandroidformine.utils.SharedPreferencesUtils
import okhttp3.Interceptor
import okhttp3.Response


/**
 *
 *   AddCookieInterceptor
 *   @meaning
 *   @remarks
 *  ╮(￣▽￣)╭
 *   @author QJ Shi
 *   @date 2022/9/13
 */
class AddCookieInterceptor : Interceptor {

    private val COOKIE_NAME = "Cookie"

    override fun intercept(chain: Interceptor.Chain?): Response {
        val request = chain?.request()
        val domain = request?.url()?.host()
        val builder = request?.newBuilder()
        val userId = SharedPreferencesUtils.getInt(SharePreferencesContants.USER_ID)
        if (domain!!.isNotEmpty() && userId != 0) {
            var cookies = SharedPreferencesUtils.getString(domain)
            cookies?.let {
                builder?.addHeader(COOKIE_NAME, cookies)
            }
//            if (cookies!!.isNotEmpty()) {
//
//            }
        }
        return chain.proceed(builder?.build())
    }

}