package com.example.wanandroidformine.net.schedules

import io.reactivex.ObservableTransformer
import io.reactivex.Scheduler


/**
 *
 *   BaseSchedulerProvider
 *   @meaning  线程切换拓展类
 *   @remarks
 *  ╮(￣▽￣)╭
 *   @author QJ Shi
 *   @date 2022/9/13
 */
interface BaseSchedulerProvider {
    open fun computation(): Scheduler
    open fun io() : Scheduler
    open fun ui(): Scheduler
    open fun <T> applySchedulers(): ObservableTransformer<T, T>
}